#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire200five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
 
global shot2five2004xi    


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five2004xi = {
                1: '-100x21y171z',
                2: '-101x112y129z',
                3: '-102x100y138z',
                4: '-103x16y170z',
                5: '-105x11y169z',
                6: '-106x159y57z',
                7: '-108x108y128z',
                8: '-108x6y168z',
                9: '-109x0y167z',
                10: '-109x95y137z',
                11: '-10x1y199z',
                12: '-114x103y126z',
                13: '-115x153y55z',
                14: '-115x90y136z',
                15: '-120x85y134z',
                16: '-121x98y125z',
                17: '-123x148y53z',
                18: '-126x79y133z',
                19: '-127x92y123z',
                20: '-12x0y199z',
                21: '-12x61y189z',
                22: '-131x141y51z',
                23: '-131x73y131z',
                24: '-132x86y122z',
                25: '-136x67y130z',
                26: '-138x135y49z',
                27: '-138x79y120z',
                28: '-140x60y128z',
                29: '-143x72y118z',
                30: '-144x53y127z',
                31: '-146x128y47z',
                32: '-147x65y117z',
                33: '-148x46y125z',
                34: '-14x0y199z',
                35: '-14x134y147z',
                36: '-152x38y123z',
                37: '-152x58y115z',
                38: '-153x120y45z',
                39: '-155x30y122z',
                40: '-156x50y114z',
                41: '-157x22y120z',
                42: '-159x112y43z',
                43: '-159x14y119z',
                44: '-159x42y112z',
                45: '-162x34y110z',
                46: '-165x104y41z',
                47: '-165x26y109z',
                48: '-167x17y107z',
                49: '-169x8y105z',
                50: '-16x0y199z',
                51: '-16x62y189z',
                52: '-170x0y104z',
                53: '-171x95y39z',
                54: '-176x86y37z',
                55: '-180x77y35z',
                56: '-184x68y33z',
                57: '-188x58y31z',
                58: '-191x48y29z',
                59: '-194x38y27z',
                60: '-196x28y25z',
                61: '-197x18y23z',
                62: '-198x7y21z',
                63: '-20x63y188z',
                64: '-21x124y155z',
                65: '-21x135y145z',
                66: '-21x184y74z',
                67: '-242x9y176z',
                68: '-24x64y187z',
                69: '-28x124y153z',
                70: '-28x135y144z',
                71: '-28x64y187z',
                72: '-2x0y199z',
                73: '-31x183y72z',
                74: '-32x64y186z',
                75: '-34x124y152z',
                76: '-36x134y143z',
                77: '-37x64y185z',
                78: '-41x123y151z',
                79: '-41x182y70z',
                80: '-41x64y184z',
                81: '-43x134y141z',
                82: '-45x63y184z',
                83: '-48x122y150z',
                84: '-4x1y199z',
                85: '-50x62y183z',
                86: '-51x133y140z',
                87: '-51x180y68z',
                88: '-54x60y182z',
                89: '-55x121y148z',
                90: '-58x131y138z',
                91: '-58x59y181z',
                92: '-60x178y66z',
                93: '-62x119y147z',
                94: '-63x57y180z',
                95: '-65x129y137z',
                96: '-67x55y179z',
                97: '-69x117y145z',
                98: '-6x1y199z',
                99: '-6x59y190z',
                100: '-70x175y64z',
                101: '-71x52y179z',
                102: '-73x127y135z',
                103: '-76x114y144z',
                104: '-76x49y178z',
                105: '-79x172y62z',
                106: '-80x124y134z',
                107: '-80x46y177z',
                108: '-83x111y143z',
                109: '-83x43y176z',
                110: '-87x120y132z',
                111: '-87x39y175z',
                112: '-88x168y60z',
                113: '-8x1y199z',
                114: '-90x108y141z',
                115: '-91x35y174z',
                116: '-94x117y131z',
                117: '-94x31y173z',
                118: '-96x104y140z',
                119: '-97x164y58z',
                120: '-97x26y172z',
                121: '-9x60y190z',
                122: '0x0y199z'}

#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire200five4xi" usage = "target function for charge2004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire200five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE200FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE200FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE200FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE200FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE200FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five2004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE200FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE200FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE200FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five2004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five2004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE200FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE200FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE200FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire200five4xi.py                             
# -------------------------------------------------------------------------------------------------                